; The bootstrap program -- sits in some memory somewhere and is able to download data
; from the azz80's serial port.

            ORG 2000h

; Initialise.
            LD SP,2FFFh

            LD A,10011000b
            OUT (23h),A
            LD A,00001111b
            OUT (22h),A
            LD A,00000101b
            OUT (22h),A
            LD A,00001111b
            OUT (22h),A

; Wait for a zero to be sent.
nozero:     CALL serin
            CP 00h
            JR NZ,nozero

; Get the starting address.
            CALL serin
            LD H,A
            CALL serin
            LD L,A
            PUSH HL

; Get the length.
            CALL serin
            LD B,A
            CALL serin
            LD C,A

; Get the data.
dloop:      CALL serin
            LD (HL),A
            OUT (0h),A
            INC HL
            DEC BC
            LD A,B
            OR C
            JR NZ,dloop

; Run the program.
            POP HL
			JR nozero		; ... and wait for another program.

serin:      IN A,(22h)
            BIT 4,A
            JR Z,serin
            LD A,01110010b
            OUT (23h),A
            LD A,01110011b
            OUT (23h),A
            IN A,(20h)
            RET


			END
